<?php

/**
 * Tasks. 
 * 1. Add Phone Number, OTP Code to Users.
 * 2. Show the New fields on the User Listing Page. 
 * @package  WordPress
 */
add_action('edit_user_profile_update', 'brOTP_update_phonenumber_field');
add_action('personal_options_update', 'brOTP_update_phonenumber_field');
add_action('user_register', 'brOTP_update_phonenumber_field');
add_action('edit_user_profile', 'brOTP_add_phonenumber_field');
add_action('show_user_profile', 'brOTP_add_phonenumber_field');
add_action('user_new_form', 'brOTP_add_phonenumber_field_to_new_form');

// Filters
add_filter('manage_users_columns', 'brOTP_modify_user_table');
add_filter('manage_users_custom_column', 'brOTP_modify_user_table_row', 10, 3);
add_filter('manage_users_sortable_columns',  'brOTP_make_registered_date_column_sortable');

/**
 * This function adds the phone number field to the user profile
 * @param  object $user The user object
 * @return void
 */
function brOTP_add_phonenumber_field_to_new_form($user)
{
    //$phn = get_the_author_meta('phone_number', $user->ID)
?>
    <h3><?php esc_html_e('Personal Information', 'crf'); ?></h3>

    <table class="form-table">
        <tr>
            <th><label for="phone_number"><?php esc_html_e('phone_number', "otp-login"); ?></label></th>
            <td>
                <input type="text" id="phone_number" name="phone_number" value="" class="regular-text" />

            </td>
        </tr>
    </table>
<?php
}
/**
 * 
 */
function brOTP_add_phonenumber_field($user)
{
    $phn = get_the_author_meta('phone_number', $user->ID);
?>
    <h3><?php esc_html_e('Personal Information', 'crf'); ?></h3>

    <table class="form-table">
        <tr>
            <th><label for="phone_number"><?php esc_html_e('phone_number', "otp-login"); ?></label></th>
            <td>
                <input type="text" step="1" id="phone_number" name="phone_number" value="<?php echo esc_attr($phn); ?>" class="regular-text" />

            </td>
        </tr>
    </table>
<?php
}
function brOTP_update_phonenumber_field($user_id)
{
    if (!current_user_can('edit_user', $user_id)) {
        return false;
    }
    update_user_meta($user_id, 'phone_number', $_POST['phone_number']);
}


function brOTP_modify_user_table($column)
{
    $column['phone_number'] = __('Phone number', "otp-login");
    $column['activation_code'] = __('Activation code', "otp-login");
    $column['registered_date'] = __('Registered date', "otp-login");
    return $column;
}
function brOTP_modify_user_table_row($val, $column_name, $user_id)
{
    $udata = get_userdata($user_id);
    switch ($column_name) {
        case 'phone_number':
            return get_the_author_meta('phone_number', $user_id);
        case 'activation_code':
            return get_the_author_meta('activation_code', $user_id);
        case 'registered_date':
            return $udata->user_registered;
        default:
    }
    return $val;
}
function brOTP_make_registered_date_column_sortable($columns)
{
    return wp_parse_args(array('registered_date' => 'registered'), $columns);
}
