<?php
function register_field_style()
{ ?>
    <style type="text/css">
        .login form .input,
        .login select,
        .login textarea,
        .login input[type=color],
        .login input[type=date],
        .login input[type=datetime-local],
        .login input[type=month],
        .login input[type=number],
        .login input[type=search],
        .login input[type=tel],
        .login input[type=time],
        .login input[type=range],
        .login input[type=url],
        .login input[type=week],
        .login input[type=week] {
            font-size: 24px;
            line-height: 1.33333333;
            width: 100%;
            border-width: 0.0625rem;
            padding: 0.1875rem 0.3125rem;
            margin: 0 6px 16px 0;
            min-height: 40px;
            max-height: none;
        }

        .login form,
        .login input[type=radio] {
            font-size: 24px;
            /* line-height: 1.33333333; */
            /* width: 100%; */
            /* border-width: 0.0625rem; */
            /* padding: 0.1875rem 0.3125rem; */
            /* margin: 0 6px 16px 0; */
            /* min-height: 40px; */
            /* max-height: none; */
        }
    </style>
<?php
}
add_action('login_head', 'register_field_style');


include("braveUser.php");


// =========================================================================
// Read fields from the OPTIONs and add it to Edit, Add and Profile fields. 
// =========================================================================

add_action('init', 'addFieldsToUser');

function addFieldsToUser()
{


    $user = new braveUser();
    $fields = get_option("braveWPUser");

    if ($fields != "") {

        $field_array = json_decode($fields, true);

        for ($i = 0; $i < count($field_array); $i++) {
            $fieldName = $field_array[$i]["fieldName"];
            $fieldType = $field_array[$i]["fieldType"];
            $optionData = array();
            if (isset($field_array[$i]["optionData"])) {
                $optionData = $field_array[$i]["optionData"];
            }

            $field = new wpUserField();
            $field->setName($fieldName);
            $field->setLabel($fieldName);
            $field->setPlaceholder("Enter your " . $fieldName);
            $field->setInputType($fieldType);

            if (current_user_can('administrator')) {
                $field->setPostFixHTML("<div  data='" . $fieldName . "' class='deleteField'>Delete Field</div>");
            }

            // of not logged in user
            if (!is_user_logged_in()) {
                $field->setFieldWrapper("stacked");
            }


            $array_option = array();

            foreach ($optionData as $key => $value) {
                $optionItem = array();
                //   print_r($value);
                $optionItem[] = $value["value"];
                $optionItem[] = $value["label"];
                $array_option[] = $optionItem;
            }
            $field->setOptions($array_option);

            $user->addField($field);
        }
    }

    // Show FORM. 
    // AJAX TO _brave_add_field


    if (current_user_can('administrator')) {
        add_action('edit_user_profile', 'addDynamicFields');
        add_action('show_user_profile', 'addDynamicFields');
        add_action('user_new_form', 'addDynamicFields');

        // Add field to registration. 

    }
    //add_action('register_form', 'addDynamicFields');
}




function addDynamicFields()
{
?>

    <div class="new-field" id="BrAddField">
        NEED A NEW USER FIELD ?
    </div>
    <style>
        .deleteField {
            cursor: pointer
        }

        .deleteField:hover {
            color: red;
            text-decoration: underline;
        }

        .new-field {
            margin-top: 10px;
            margin-bottom: 10px;
            border: 2px dashed grey;
            padding: 5px;
            text-align: center;
            font-weight: 500;
            border-radius: 5px;
            cursor: pointer;
            max-width: 550px;
            color: gray;
        }

        #options-for-input {
            border: 1px solid grey;
            padding: 5px;
            margin: 5px;
        }

        #new-option-form {
            display: flex;
            gap: 10px;
            align-items: center;

        }

        #closebrAddForm {

            float: right;
        }
    </style>
    <div id="brAddForm" style="display: none; border: 1px dashed gray; padding: 20px">
        <button type="button" id="closebrAddForm">Close X</button>

        <label for="fieldName">Field Name</label>
        <input type="text" id="fieldname" name="fieldName" />
        <br />
        <label for="fieldType">Field Type </label>
        <!-- <input type="text" id="fieldType" name="fieldType" value="text" /> -->
        <select id="fieldType" name="fieldType" value="">
            <option value="text">text</option>
            <option value="textarea">Textarea</option>
            <option value="radio">radio</option>
            <option value="select">Select</option>
            <option value="checkbox">checkbox</option>
            <option value="color">color</option>
            <option value="date">date</option>
            <option value="datetime-local">datetime-local</option>
            <option value="month">month</option>
            <option value="number">number</option>
            <option value="password">password</option>
            <option value="range">range</option>
            <option value="search">search</option>
            <option value="tel">tel</option>
            <option value="time">time</option>
            <option value="url">url</option>
            <option value="week">week</option>
        </select>

        <div id="options-for-input" style="display:none;">
            <div><b>Field Options</b></div>
            <div id="existingOptions">

            </div>
            <div id="new-option-form">
                <label for="option_label">Option Label</label>
                <input type="text" id="option_label" name="option_label" />
                <br />
                <label for="option_value">Option Value </label>
                <input type="text" id="option_value" name="option_value" value="text" />
                <button id="add_option" type="button">Add Option</button>
            </div>


        </div>



        <div id="sendAjaxRequestToAdd" class="button button-primary">Add Field</div>
    </div>

    <script>
        document
            .getElementById('BrAddField')
            .addEventListener('click', function() {
                document.getElementById('brAddForm').style.display = 'block';
            });


        // Adding Delete for the input fields. 

        var elements = document.getElementsByClassName("deleteField");

        var myFunction = function() {
            if (!confirm('Delete this field?')) {
                return;
            }
            var fieldName = this.getAttribute("data");
            alert(fieldName);
            ///
            this.innerHTML = "Deleting ..."

            const formData = new FormData();
            formData.append('action', 'brave_delete_field');
            formData.append('fieldname', fieldName);

            const formDataSP = new URLSearchParams(formData);
            var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
            fetch(ajaxurl, {
                    method: 'POST',
                    credentials: 'same-origin',
                    headers: {
                        "Content-Type": "application/x-www-form-urlencoded"
                    },
                    body: formDataSP,
                })
                .then((response) => {
                    console.log(response);
                    return response.json()
                })
                .then((res) => {
                    console.log(res);
                    if (res.type === "success") {
                        console.log(res.message)
                        location.reload();
                    }
                }).catch((error) => {
                    console.log(error)
                })


        };




        for (var i = 0; i < elements.length; i++) {
            elements[i].addEventListener('click', myFunction, false);
        }





        document.getElementById("closebrAddForm").addEventListener("click", function() {
            document.getElementById('brAddForm').style.display = 'none';
        })

        // Show and hide the optiosn based on the input type value. 
        document.getElementById("fieldType").addEventListener("change", function() {
            var fieldType = document.getElementById("fieldType").value;
            if (fieldType == "select" || fieldType == "radio") {
                document.getElementById("options-for-input").style.display = "block";
            } else {
                document.getElementById("options-for-input").style.display = "none";
            }

        })


        var field_options = [];


        function deleteOption(index) {
            field_options.splice(index, 1);
            addFieldOptionsToDom();
        }

        function addFieldOptionsToDom() {
            var elContainer = document.getElementById("existingOptions");
            elContainer.innerHTML = "";
            for (let i = 0; i < field_options.length; i++) {
                element = field_options[i];

                var para = document.createElement("p");
                var div = document.createElement("div");
                div.addEventListener("click", function() {
                    if (confirm("Delete?")) {
                        deleteOption(i);
                    }
                });
                var node = document.createTextNode("label: " + element.label + " value: " + element.value);
                var deleteIcon = document.createTextNode(" X delete ");

                div.appendChild(deleteIcon);
                para.appendChild(node);
                para.appendChild(div);


                elContainer.appendChild(para);

            }

        }

        document.getElementById("add_option").addEventListener("click", addOptionsToOptioArray);


        function addOptionsToOptioArray() {
            if (document.getElementById('option_label').value == "" && document.getElementById('option_value').value == "") {
                alert("should not be blank");
                return document.getElementById('option_label').value;
                return document.getElementById('option_value').value;
            }
            field_options.push({
                value: document.getElementById("option_value").value,
                label: document.getElementById("option_label").value,
            });
            console.log(field_options);
            document.getElementById('option_label').value = "";
            document.getElementById('option_value').value = "";
            addFieldOptionsToDom()
        }



        // Send data to the server 
        document.getElementById('sendAjaxRequestToAdd').addEventListener('click', function() {
            if (document.getElementById('fieldname').value == "") {
                alert("Should not blank!");
                return document.getElementById('fieldname').value;
            }
            document.getElementById("sendAjaxRequestToAdd").innerHTML = "Adding..."

            const formData = new FormData();
            formData.append('action', 'brave_add_field');
            formData.append('fieldname', document.getElementById('fieldname').value);
            formData.append('fieldType', document.getElementById('fieldType').value);
            formData.append('optionData', JSON.stringify(field_options));

            const formDataSP = new URLSearchParams(formData);
            var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
            fetch(ajaxurl, {
                    method: 'POST',
                    credentials: 'same-origin',
                    headers: {
                        "Content-Type": "application/x-www-form-urlencoded"
                    },
                    body: formDataSP,
                })
                .then((response) => {
                    console.log(response);
                    return response.json()
                })
                .then((res) => {
                    console.log(res);
                    if (res.type === "success") {
                        console.log(res.message)
                        location.reload();
                    }
                }).catch((error) => {
                    console.log(error)
                })
        });
    </script>
<?php
}


add_action('wp_ajax_brave_delete_field', 'brDeleteField');

function brDeleteField()
{

    if (!current_user_can('administrator')) {
        $response = array(
            "message" => "Requires Admin Access",
            "type" => "error"
        );
    }

    $fieldname = $_POST['fieldname'];
    $fields = get_option("braveWPUser");




    if ($fields == "") {
        $fields = array();
        add_option("braveWPUser", "");
    } else {
        $fields = json_decode($fields, true);
    }


    for ($i = 0; $i < count($fields); $i++) {
        # code...
        if ($fields[$i]["fieldName"] == $fieldname) {
            unset($fields[$i]);
            $fields = array_values($fields);
        }
    }

    $updateString = json_encode($fields);
    // print_r($fields);
    // echo     $updateString;

    update_option("braveWPUser", $updateString);

    $response = array(
        "message" => "Form Field deleted successfully",
        "type" => "success"
    );

    echo json_encode($response);

    wp_die();
}



// creating a wordpress end point to send OTP
add_action('wp_ajax_brave_add_field', 'brAddField');
//add_action( 'wp_ajax_nopriv_login_with_otp', 'login_with_otp_ajax' );
function brAddField()
{

    if (!current_user_can('administrator')) {
        $response = array(
            "message" => "Requires Admin Access",
            "type" => "error"
        );
    }
    $fieldname = $_POST['fieldname'];
    $fieldType = $_POST['fieldType'];
    $optionData = $_POST['optionData'];
    //echo $_POST['optionData'];
    //$optionData = '[{"value":"dasfadf","label":"adfdasf"},{"value":"dasfadf","label":"adfdasf"}]';
    //  echo  "====>";
    // print_r(stripslashes($optionData));

    $fields = get_option("braveWPUser");
    //  $fields = "";

    if ($fields == "") {
        $fields = array();
        add_option("braveWPUser", "");
    } else {
        $fields = json_decode($fields);
    }

    $fields[] = array(
        "fieldName"     =>  $fieldname,
        "fieldType"     =>  $fieldType,
        "optionData"    =>  json_decode(stripslashes($optionData), true),
    );

    $updateString = json_encode($fields);

    update_option("braveWPUser", $updateString);


    // echo get_option("braveWPUser");

    $response = array(
        "message" => "Form Field added successfully",
        "type" => "success"
    );

    echo json_encode($response);

    wp_die();
}
